---
title: Reflect.defineProperty()
slug: Web/JavaScript/Reference/Global_Objects/Reflect/defineProperty
tags:
  - ECMAScript 2015
  - JavaScript
  - Method
  - Reference
  - Reflect
---
<div>{{JSRef}}</div>

<p>The static <strong><code>Reflect.defineProperty()</code></strong> method is like {{jsxref("Object.defineProperty()")}} but returns a {{jsxref("Boolean")}}.</p>

<div>{{EmbedInteractiveExample("pages/js/reflect-defineproperty.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Reflect.defineProperty(<var>target</var>, <var>propertyKey</var>, <var>attributes</var>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>target</var></code></dt>
 <dd>The target object on which to define the property.</dd>
 <dt><code><var>propertyKey</var></code></dt>
 <dd>The name of the property to be defined or modified.</dd>
 <dt><code><var>attributes</var></code></dt>
 <dd>The attributes for the property being defined or modified.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Boolean")}} indicating whether or not the property was successfully defined.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>A {{jsxref("TypeError")}}, if <code><var>target</var></code> is not an {{jsxref("Object")}}.</p>

<h2 id="Description">Description</h2>

<p>The <code>Reflect.defineProperty</code> method allows precise addition to or modification of a property on an object. For more details, see the {{jsxref("Object.defineProperty")}} which is similar.</p>

<div class="notecard note">
<p><strong>One key difference:</strong> <code>Object.defineProperty</code> returns the object or throws a {{jsxref("TypeError")}} if the property has not been successfully defined. <code>Reflect.defineProperty</code>, however, returns a {{jsxref("Boolean")}} indicating whether or not the property was successfully defined.</p>
</div>

<h2 id="Examples">Examples</h2>

<h3 id="Using_Reflect.defineProperty">Using Reflect.defineProperty()</h3>

<pre class="brush: js notranslate">let obj = {}
Reflect.defineProperty(obj, 'x', {value: 7})  // true
obj.x                                         // 7
</pre>

<h3 id="Checking_if_property_definition_has_been_successful">Checking if property definition has been successful</h3>

<p>With {{jsxref("Object.defineProperty")}}, which returns an object if successful, or throws a {{jsxref("TypeError")}} otherwise, you would use a <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/try...catch">try...catch</a></code> block to catch any error that occurred while defining a property.</p>

<p>Because <code>Reflect.defineProperty</code> returns a Boolean success status, you can just use an <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/if...else">if...else</a></code> block here:</p>

<pre class="brush: js notranslate">if (Reflect.defineProperty(target, property, attributes)) {
  // success
} else {
  // failure
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-reflect.defineproperty', 'Reflect.defineProperty')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Reflect.defineProperty")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Reflect")}}</li>
 <li>{{jsxref("Object.defineProperty()")}}</li>
</ul>
